<?php

class Table {
	// ressource mysql. Utilisateurs séléctionnés, au nombre de $display_count
	var $users;
	// string.
	var $sortby;
	// bool. Si la colonne $sortby doit être inversée.
	var $inv;
	// page à laquelle on est.
	var $page;
	// nombre de résultats à afficher
	var $display_count;
	// termes de recherche
	var $search;
	// nombre de résultats TOTAL
	var $user_count;
	// nombre de pages (raccourci)
	var $page_count;

	function Table($getvars, $cookievars) {
		$req = 'SELECT * FROM jhindex';

		/* filtrage par mot-cle */
		if (isset($getvars['search'])) {
			if (function_exists('get_magic_quotes_gpc') && get_magic_quotes_gpc())
				$search = $getvars['search'];
			else
				$search = addslashes($getvars['search']);
			$req .= " WHERE pseudo LIKE '%". $search ."%'";
			if (is_numeric($getvars['search'])) 
				$req .= " OR id='". $search ."'";
			$this->search = htmlentities(stripslashes($search), ENT_QUOTES, 'UTF-8');
		} else
			$this->search = '';
		
		/* ordre */
		if (isset($getvars['sortby']))
			$this->sortby = preg_replace('/[^a-z]/', '', $getvars['sortby']);
		else
			$this->sortby = 'arrive';
		$req .= " ORDER BY ". $this->sortby;

		/* possible inversion de l'ordre */
		if (isset($getvars['inv']) && $getvars['inv'] == 1) {
			$this->inv = 1;
			/* le triage est opposé pour les champs 'messages' et 'postpj'.
			 * selon conseils de Grumly @ quakenet, interweb ergonomic expert */
			if ($this->sortby != 'messages' && $this->sortby != 'postpj')
				$req .= ' DESC';
		} else {
			$this->inv = 0;
			if ($this->sortby == 'messages' || $this->sortby == 'postpj')
				$req .= ' DESC';
		}
		/* ensuite classé par id */
		$req .= ', id';
		if ($this->sortby == 'arrive' && $this->inv == 1)
			$req .= ' DESC';

		/* page */
		if (isset($getvars['page']) && is_numeric($getvars['page']) && $getvars['page'] >= 0) 
			$this->page = $getvars['page'];
		else 
			$this->page = 0;
		
		/* nombre */
		if (isset($cookievars['jhi_count']) && is_numeric($cookievars['jhi_count']))
			$this->display_count = $cookievars['jhi_count'];
		else
			$this->display_count = 40;
		$count_req = preg_replace('@^SELECT \*@', 'SELECT COUNT(*)', $req);
		$req .= " LIMIT ". $this->page*$this->display_count .','. $this->display_count;

		#echo "<p style='text-align: center;font-weight:bold' >$req</p>";
		$this->users = mysql_query($req) or die(mysql_error());
		$res = mysql_query($count_req) or die(mysql_error());
		$arr = mysql_fetch_array($res);
		$this->user_count = $arr[0];
		/* variables additionnelles .. */
		$this->page_count = ceil($this->user_count/$this->display_count)-1;
		if ($this->page > $this->page_count)
			$this->page = $this->page_count;
	}
}

class TableRenderer {
	// html
	var $output;
	// table à rendre
	var $table;
	// code pour l'element $search
	var $search_str;
	// nombre de liens de page à afficher avant la page actuelle (avec 3: 1 2 3 [4] 5 6 7)
	var $page_range;

	function TableRenderer($table) {
		$this->table = $table;
		$this->page_range = 3;

		if ($this->table->search)
			$this->search_str = '&amp;search=' .$this->table->search;
		else
			$this->search_str = '';

		/* barre de recherche */
		$this->output = '<form action="." method="get">';
		$this->output .= '<p>Entrez un numéro ou un bout de nom d\'utilisateur ..<br />';
		$this->output .= '<input type="text" class="entree" name="search" value="'. $this->table->search .'"/><br />';
		$this->output .= '<input type="submit" value="Rechercher" />';
		$this->output .= '</p>';
		$this->output .= "</form>\n";
		$this->output .= '<p>'. $this->table->user_count .' résultats</p>';

		/* form de mise à jour individuelle */
		$this->output .= '<form action="." method="post">';
		$this->addPagesNavigator();

		$first = TRUE;
		$row_number = 1;
		while ($user = mysql_fetch_assoc($this->table->users)) {
			if ($first) {
				$this->output .= '<table border="1"><thead><tr>';
				/* titres des colonnes */
				$human_name = array(
					'pseudo' => 'Pseudo',
					'id' => 'id',
					'messages' => 'Messages',
					'arrive' => 'Arrivée',
					'postpj' => 'Msg/j',
				);
				foreach ($user as $key => $value) {
					if ($key == $this->table->sortby)
						$style = ' id="hl"';
					else
						$style = '';
					if ($key == $this->table->sortby && $this->table->inv == 0) {
						$bonus = '&amp;inv=1';
					} else
						$bonus = '';

					$this->output .= sprintf('<th%s><a href="?sortby=%s%s%s&amp;page=%s">%s</a></th>',
						$style, $key, $bonus, $this->search_str, $this->table->page, $human_name[$key]);
				}
				$this->output .= '<th>màj</th>';
				$this->output .= '</tr></thead>';
				$first = FALSE;
			}

			/* contenu du tableau */
			$this->output .= '<tr>';
			foreach ($user as $key => $value) {
				if ($key == 'arrive')
					$value = strftime("%d/%m/%Y", $value);
				else if ($key == 'pseudo') {
					// position dans le classement
					$numbering = '<span class="numbering">'. ($this->table->page*$this->table->display_count + $row_number) .'</span>';
					$row_number++;
					// lien vers le profil
					$value = $numbering . '<a href="http://forum.judgehype.com/judgehype/profil-'.$user['id'].'.htm">'.$value.'</a>';
				} else if ($key == 'postpj') {
					if ($value != NULL)
						$value = round($value, 2);
					else
						$value = 'NA';
				} 
				$this->output .= "<td>$value</td>";
			}
			$this->output .= sprintf('<td><input type="checkbox" name="ids[]" value="%s" /></td>', $user['id']);
			$this->output .= '</tr>';
		}
		if (!$first)
			$this->output .= '</table>';

		$this->addPrevNext();
		/* "panneau de contrôle" */
		$this->output .= '<div id="topleft">';
		$this->output .= '<p>Recharge le profil des membres cochés : <input type="submit" value="Màj sélectionnés" name="update_single" /></p>';
		$this->output .= '<form action="." method="post"><p>Vérifie le nombre de membres et complète la base de donnée : <input type="submit" name="update" value="Compléter la base" /></p></form>';
		$this->output .= '<form action="." method="post"><p>Nombre de résultats par page (cookie) : <input type="text" style="width: 30px" name="results" value="'. $this->table->display_count .'" /> <input type="submit" value="OK" /></p></form>';
		$this->output .= '</div>';
		$this->output .= '</form>';

	}

	function addPrevNext() {
		/* ajoute des boutons suivant / précédent à $this->output */
		$this->output .= '<p>';
		if ($this->table->page > 0)
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button">&lt;</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $this->table->page-1);
		else
			$this->output .= '<span class="button">&lt;</span>';
		if ($this->table->page == $this->table->page_count)
			$this->output .= '<span class="button">&gt;</span>';
		else
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button">&gt;</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $this->table->page+1);
		$this->output .= "</p>\n";
	}

	function addPagesNavigator() {
		$this->output .= '<p>';
		/* début */
		$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button" title="Début">&lt;&lt;</a>',
			$this->table->sortby, $this->table->inv, $this->search_str, 0);
		/* précédent */
		if ($this->table->page > 0) {
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button" title="Précédent">&lt;</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $this->table->page-1);
			$this->output .= '...';
		}
		else
			$this->output .= '<span class="button">&lt;</span>';

		/* milieu début/actuel */
		$first_middle = floor($this->table->page/2);
		if ($first_middle != 0 && $first_middle < $this->table->page - $this->page_range) {
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button">%s</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $first_middle, $first_middle);
			$this->output .= '...';
		}
		/* 3 avant actuel */
		$before_current = $this->table->page;
		if ($before_current > $this->page_range)
			$before_current = $this->page_range;
		while ($before_current > 0) {
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button">%s</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $this->table->page-$before_current, $this->table->page-$before_current);
			$before_current--;
		}
		/* actuel */
		$this->output .= '<span class="button" id="button_hl">'. $this->table->page .'</span>';

		/* 3 après actuel */
		$after_current = $this->table->page_count - $this->table->page;
		if ($after_current > $this->page_range)
			$after_current = $this->page_range;
		$i = 1;
		while ($i < $after_current+1) {
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button">%s</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $this->table->page+$i, $this->table->page+$i);
			$i++;
		}

		/* milieu actuel/fin */
		$last_middle = floor(($this->table->page_count + $this->table->page)/2);
		if ($last_middle != $this->table->page_count && $last_middle > $this->table->page + $this->page_range) {
			$this->output .= '...';
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button">%s</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $last_middle, $last_middle);
		}

		/* suivant */
		if ($this->table->page == $this->table->page_count)
			$this->output .= '<span class="button">&gt;</span>';
		else {
			$this->output .= '...';
			$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button" title="Suivant">&gt;</a>',
				$this->table->sortby, $this->table->inv, $this->search_str, $this->table->page+1);
		}
		/* fin */
		$this->output .= sprintf('<a href="?sortby=%s&amp;inv=%s%s&amp;page=%s" class="button" title="Fin">&gt;&gt;</a>',
			$this->table->sortby, $this->table->inv, $this->search_str, $this->table->page_count);

		$this->output .= "</p>\n";
	}
	function printHtml() {
		printf(file_get_contents('template.html'), 
			'JHIndex : liste des membres JH',
			$this->output);
	}
}



?>
