#!/usr/bin/env python
# -*- coding:utf-8 -*-

# profiler.py - récolte les infos des profils, affiche les commandes sql pour créer la base de donnée (programme en ligne de commande, la sortie doit être récupérée avec une redirection)

import re, urllib, sys, time

# nombre de secondes en chaque requete
INTERVAL = 1

def get_field(label, html):
	"""retourne la valeur associée à la chaine <label> dans la page de profil
	téléchargée <html>"""
	pat = re.compile(r'''<td class="profilCase2">.*?%s.*?</td>.*?<td class="profilCase3">(.*?)</td>''' % label, re.S)
	field = re.search(pat, html)
	if field:
		return re.sub( r"&.*?;", "", field.group(1).strip() )
	else:
		print html
		print "!!!"
		print "!!! Erreur: impossible de trouver '%s' dans ce html" % label
		print "!!!"
		sys.exit(0)

def date2long(date):
	return int(time.mktime(time.strptime(date, "%d/%m/%Y")))

def makesql(dic):
	"génère une requete sql pour ajouter le dictionnaire <dic>"
	return "INSERT INTO jhindex(%s) VALUES('%s');" % (
			", ".join(dic.keys()),
			"', '".join(dic.values())
			)

def get_total_members():
	"renvoie le nombre de membre inscrits"
	html = urllib.urlopen("http://forum.judgehype.com/").read()
	members = re.search("Membres Enregistrés : <b>([0-9]*)</b>", html).group(1)
	return int(members)

if __name__ == '__main__':
	print "DELETE FROM jhindex;"
	members = get_total_members()
	userid = 0
	while (members > 0):
		html = urllib.urlopen("http://forum.judgehype.com/judgehype/profil-%s.htm" % userid).read()
		if "ce pseudo n'existe pas" in html:
			userid += 1
			continue
		member = {'id':str(userid)}
		member['arrive'] = str(date2long(get_field('arriv', html)))
		for info in ('Pseudo', 'messages'):
			member[info.lower()] = get_field(info, html)

		members -= 1
		print makesql(member)
		sleep(INTERVAL)
